<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
      </template>
      <template slot="applicationStatus" slot-scope="{row}">
        <el-tag plain type="warning" size="small" v-if="row.applicationStatus == 100">资料完善中</el-tag>
        <el-tag plain type="primary" size="small" v-if="row.applicationStatus == 98">送审中</el-tag>
        <el-tag plain type="warning" size="small" v-if="row.applicationStatus == 101">协议待签署</el-tag>
        <el-tag plain type="warning" size="small" v-if="row.applicationStatus == 102">审核中</el-tag>
        <el-tag plain type="success" size="small" v-if="row.applicationStatus == 200">审核成功</el-tag>
        <el-tag plain type="danger" size="small" v-if="row.applicationStatus == 400">审核失败</el-tag>
        <el-tag plain type="danger" size="small" v-if="row.applicationStatus == 99">送审失败</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/bussinessmng/bussinessregisterrequest";
  import {mapGetters} from "vuex";

  export default {
    props:{
      bussinessInfoId: null,
      userInfoId: null
    },
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          editDisplay: false,
          addDisplay: false,
          delBtn: false,
          menu: false,
          column: [
            {
              label: "进件请求号",
              prop: "requestNo",
            },
            {
              label: "采购商主体名称",
              prop: "bussinessInfoId",
              labelWidth: 120,
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bussiness-info/bussinessinfo/listBussinessInfo?size=500",
              props:{
                label: "signName",
                value: "id"
              },
            },
            {
              label: "用户名称",
              prop: "userInfoId",
              type: "select",
              filterable: true,
              dicUrl: "/api/cyzh-bussiness-user-info/bussinessuserinfo/listUserInfo",
              props:{
                label: "userName",
                value: "id"
              },
            },
            {
              label: "申请状态",
              prop: "applicationStatus",
              slot: true,
              display: false
            },
            {
              label: "审核意见",
              prop: "auditOpinion",
            },
            {
              label: "申请时间",
              width: 150,
              prop: "createTime",
            },
            {
              label: "更新时间",
              width: 150,
              prop: "updateTime",
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.bussinessregisterrequest_add, false),
          viewBtn: this.vaildData(this.permission.bussinessregisterrequest_view, false),
          delBtn: this.vaildData(this.permission.bussinessregisterrequest_delete, false),
          editBtn: this.vaildData(this.permission.bussinessregisterrequest_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        if(this.bussinessInfoId != null){
          params['bussinessInfoId'] = this.bussinessInfoId;
        }
        if(this.userInfoId != null){
          params['userInfoId'] = this.userInfoId;
        }
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
